=== test/Makefile ===
# -*- Mode: makefile-gmake -*-

all:
%:
	@$(MAKE) -C binder-bridge $*
	@$(MAKE) -C binder-client $*
	@$(MAKE) -C binder-dump $*
	@$(MAKE) -C binder-list $*
	@$(MAKE) -C binder-ping $*
	@$(MAKE) -C binder-service $*
	@$(MAKE) -C binder-call $*
	@$(MAKE) -C rild-card-status $*
