=== test/ashmem-test/Makefile ===
# -*- Mode: makefile-gmake -*-

EXE = ashmem-test

include ../common/Makefile
