=== test/binder-bridge/Makefile ===
# -*- Mode: makefile-gmake -*-

EXE = binder-bridge

include ../common/Makefile
