=== test/binder-client/Makefile ===
# -*- Mode: makefile-gmake -*-

EXE = binder-client

include ../common/Makefile
