=== test/binder-dump/Makefile ===
# -*- Mode: makefile-gmake -*-

EXE = binder-dump

include ../common/Makefile
