=== test/binder-list/Makefile ===
# -*- Mode: makefile-gmake -*-

EXE = binder-list

include ../common/Makefile
