=== test/binder-ping/Makefile ===
# -*- Mode: makefile-gmake -*-

EXE = binder-ping

include ../common/Makefile
