=== test/binder-service/Makefile ===
# -*- Mode: makefile-gmake -*-

EXE = binder-service

include ../common/Makefile
