=== debian/changelog ===
libgbinder (1.1.42) unstable; urgency=low

  * Delete name watches with no handlers
  * Register for sm notifications asynchronously
  * Correct stability field wire format on Android 12

 -- Slava Monich <slava@monich.com>  Wed, 11 Dec 2024 06:40:00 +0200

libgbinder (1.1.41) unstable; urgency=low

  * Fix sending NULL binder object
  * Added gbinder_reader_read_nullable_string8
  * Check if counted strings are NULL-terminated

 -- Slava Monich <slava@monich.com>  Sat, 02 Nov 2024 05:13:22 +0200

libgbinder (1.1.40) unstable; urgency=low

  * Make stability field of local object configurable
  * Make more unit tests independent on system config
  * Use UNDECLARED stability for NULL binders

 -- Slava Monich <slava@monich.com>  Thu, 18 Jul 2024 05:14:28 +0300

libgbinder (1.1.39) unstable; urgency=low

  * Eliminate defects found by Coverity

 -- Slava Monich <slava@monich.com>  Sun, 05 May 2024 20:03:44 +0300

libgbinder (1.1.38) unstable; urgency=low

  * Fixed byte array padding

 -- Slava Monich <slava@monich.com>  Sat, 02 Mar 2024 02:11:50 +0200

libgbinder (1.1.37) unstable; urgency=low

  * Fixed gbinder_driver_reply_data return value

 -- Slava Monich <slava@monich.com>  Mon, 26 Feb 2024 16:22:29 +0200

libgbinder (1.1.36) unstable; urgency=low

  * Support pkg-config cross-compilation
  * Fixed handling of UTF-16 surrogate pairs

 -- Slava Monich <slava@monich.com>  Sat, 10 Feb 2024 05:04:13 +0200

libgbinder (1.1.35) unstable; urgency=low

  * Make unit tests independent on system config
  * Use MAKE var instead of explicitly calling make

 -- Slava Monich <slava@monich.com>  Thu, 23 Nov 2023 01:42:56 +0200

libgbinder (1.1.34) unstable; urgency=low

  * Fixed binder-call help message
  * Require glib 2.32

 -- Slava Monich <slava@monich.com>  Sun, 30 Apr 2023 06:04:38 +0300

libgbinder (1.1.33) unstable; urgency=low

  * Fixed GBinderWriterType for byte and int32

 -- Slava Monich <slava@monich.com>  Sun, 26 Feb 2023 03:13:49 +0200

libgbinder (1.1.32) unstable; urgency=low

  * Improved reliability of unit tests

 -- Slava Monich <slava@monich.com>  Mon, 23 Jan 2023 11:48:00 +0200

libgbinder (1.1.31) unstable; urgency=low

  * Fixed serialization issues on big-endian
  * Refactored binder simulation for unit tests

 -- Slava Monich <slava@monich.com>  Wed, 04 Jan 2023 19:10:37 +0200

libgbinder (1.1.30) unstable; urgency=low

  * Fixed BC_ACQUIRE_DONE encoding

 -- Slava Monich <slava.monich@jolla.com>  Sun, 04 Dec 2022 19:50:10 +0200

libgbinder (1.1.29) unstable; urgency=low

  * Added gbinder_writer_append_struct_vec

 -- Slava Monich <slava.monich@jolla.com>  Fri, 25 Nov 2022 00:01:41 +0200

libgbinder (1.1.28) unstable; urgency=low

  * Allow to pass negative number as a parameter to binder-call
  * Compile tools as PIE

 -- Slava Monich <slava.monich@jolla.com>  Tue, 22 Nov 2022 18:21:29 +0200

libgbinder (1.1.27) unstable; urgency=low

  * Added gbinder_writer_append_struct()

 -- Slava Monich <slava.monich@jolla.com>  Thu, 17 Nov 2022 03:25:37 +0200

libgbinder (1.1.26) unstable; urgency=low

  * Use BINDER_TYPE_HANDLE for NULL binders
  * Fixed binder object encoding in aidl3 protocol

 -- Slava Monich <slava.monich@jolla.com>  Fri, 14 Oct 2022 16:48:29 +0300

libgbinder (1.1.25) unstable; urgency=low

  * Handle RPC protocol change at run time

 -- Slava Monich <slava.monich@jolla.com>  Tue, 19 Jul 2022 02:02:41 +0300

libgbinder (1.1.24) unstable; urgency=low

  * Bumped debhelper compat level to 7

 -- Slava Monich <slava.monich@jolla.com>  Thu, 14 Jul 2022 01:32:11 +0300

libgbinder (1.1.23) unstable; urgency=low

  * Fixed Debian build dependencies

 -- Slava Monich <slava.monich@jolla.com>  Thu, 23 Jun 2022 20:09:35 +0300

libgbinder (1.1.22) unstable; urgency=low

  * Added support for Android 12 (API level 31)
  * Made binder device configurable for binder-dump

 -- Slava Monich <slava.monich@jolla.com>  Wed, 22 Jun 2022 17:02:20 +0300

libgbinder (1.1.21) unstable; urgency=low

  * Properly finalize GBinderIpc and GBinderServicePoll

 -- Slava Monich <slava.monich@jolla.com>  Mon, 20 Jun 2022 18:53:26 +0300

libgbinder (1.1.20) unstable; urgency=low

  * Made RPC protocol selectable at runtime

 -- Slava Monich <slava.monich@jolla.com>  Sat, 11 Jun 2022 02:49:49 +0300

libgbinder (1.1.19) unstable; urgency=low

  * Added reader and writer for aidl parcelables

 -- Slava Monich <slava.monich@jolla.com>  Sun, 20 Feb 2022 03:26:24 +0200

libgbinder (1.1.18) unstable; urgency=low

  * Disassociate auto-created proxies to stop them from piling up

 -- Slava Monich <slava.monich@jolla.com>  Sat, 08 Jan 2022 15:35:56 +0200

libgbinder (1.1.17) unstable; urgency=low

  * Don't release remote proxy handle too early (sometimes hever)

 -- Slava Monich <slava.monich@jolla.com>  Fri, 07 Jan 2022 14:43:51 +0200

libgbinder (1.1.16) unstable; urgency=low

  * Make sure stale object pointers don't hang around
  * Properly shut down remote object inside the proxy
  * Read ref_count from GObject atomically

 -- Slava Monich <slava.monich@jolla.com>  Mon, 03 Jan 2022 13:58:44 +0200

libgbinder (1.1.15) unstable; urgency=low

  * Added readers and writers for int8 and int16

 -- Slava Monich <slava.monich@jolla.com>  Mon, 27 Dec 2021 15:13:23 +0200

libgbinder (1.1.14) unstable; urgency=low

  * Support for FMQ (Fast Message Queues)
  * Support for Android 11 (API level 30)
  * Made GBinderReader API slightly more NULL tolerant
  * Added gbinder_client_rpc_header()
  * Added gbinder_reader_get_data()
  * Added gbinder_writer_get_data()
  * Added gbinder_servicemanager_device()
  * Added gbinder_local_reply_append_fd()

 -- Slava Monich <slava.monich@jolla.com>  Wed, 24 Nov 2021 17:15:48 +0200

libgbinder (1.1.13) unstable; urgency=low

  * Added gbinder_writer_strdup()
  * Added gbinder_writer_append_hidl_string_copy()
  * Dropped pkgconfig requirement for devel package

 -- Slava Monich <slava.monich@jolla.com>  Thu, 28 Oct 2021 14:31:01 +0300


