## libgbinder 1.1.43

=== debian/changelog ===
libgbinder (1.1.43-0pureos1~byz1) byzantium; urgency=medium

  * Backport to byzantium

 -- Sebastian Krzyszkowiak <sebastian.krzyszkowiak@puri.sm>  Sat, 17 Jan 2026 10:58:51 +0100

libgbinder (1.1.43-0pureos1) crimson; urgency=medium

  * New upstream release
  * d/control: Bump glib dependency to 2.32
  * d/patches: Revert "Use MAKE var instead of explicitly calling make"

 -- Sebastian Krzyszkowiak <sebastian.krzyszkowiak@puri.sm>  Tue, 21 Oct 2025 17:47:37 +0200

libgbinder (1.1.26-0pureos3) byzantium; urgency=medium

  * d/rules: Point LD_LIBRARY_PATH to libgbinder's dir for help2man

 -- Sebastian Krzyszkowiak <sebastian.krzyszkowiak@puri.sm>  Sun, 20 Nov 2022 01:42:55 +0100

libgbinder (1.1.26-0pureos2) byzantium; urgency=medium

  * d/copyright: DEP-5ify
  * debian: Generate manpages with help2man

 -- Sebastian Krzyszkowiak <sebastian.krzyszkowiak@puri.sm>  Mon, 14 Nov 2022 22:44:13 +0100

libgbinder (1.1.26-0pureos1) byzantium; urgency=medium

  * Upload into byzantium

 -- Sebastian Krzyszkowiak <sebastian.krzyszkowiak@puri.sm>  Mon, 07 Nov 2022 22:34:49 +0100
