=== debian/control ===
Source: libgbinder
Section: libs
Priority: optional
Maintainer: PureOS Maintainers <pureos-project@lists.puri.sm>
XSBC-Original-Maintainer: Slava Monich <slava.monich@jolla.com>
Build-Depends: debhelper-compat (= 13), libglib2.0-dev (>= 2.32), libglibutil-dev (>= 1.0.52), flex, bison, help2man
Standards-Version: 4.5.1
Rules-Requires-Root: no
Homepage: https://github.com/mer-hybris/libgbinder
Vcs-Browser: https://source.puri.sm/Librem5/debs/libgbinder
Vcs-Git: https://source.puri.sm/Librem5/debs/libgbinder.git

Package: libgbinder1
Section: libs
Architecture: any
Depends: libglibutil1 (>= 1.0.52), ${shlibs:Depends}, ${misc:Depends}
Replaces: libgbinder
Breaks: libgbinder
Description: Binder client library
 GLib-based library for interfacing with Android's Binder.

Package: libgbinder-dev
Section: libdevel
Architecture: any
Depends: libgbinder1 (= ${binary:Version}), libglibutil-dev (>= 1.0.52), ${misc:Depends}
Description: Development files for libgbinder
 GLib-based library for interfacing with Android's Binder.

Package: libgbinder-tools
Section: utils
Architecture: any
Depends: libgbinder1, ${shlibs:Depends}, ${misc:Depends}
Description: Binder command line utilities
 GLib-based library for interfacing with Android's Binder.
